#import "OpenCVBGR2Gray.h"


@implementation OpenCVBGR2Gray : QCPatch

+(BOOL)isSafe
{
	return YES;
}

+ (BOOL)allowsSubpatchesWithIdentifier:(id)fp8
{
	return NO;
}

- (id)initWithIdentifier:(id)fp8
{
	if(self = [super initWithIdentifier:fp8])
	{
		[inputImage setType:OPENCV_IMAGE];
		[outputImage setType:OPENCV_IMAGE];
	}

	return self;
}

- (void)disable:(QCOpenGLContext *)context
{
	if(img)
	{
		cvReleaseImage(&img);
		img = NULL;
	}
}


- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments
{
	IplImage *frame = [[inputImage cvObjectValue] value];
	if(frame && frame->nChannels > 1 )
	{
		if(img == NULL || frame->width != img->width || frame->height != img->height)
		{
			if(img)
				cvReleaseImage(&img);
			img = cvCreateImage(cvGetSize(frame), frame->depth, 1);
		}
		if(frame->nChannels == 3)
			cvCvtColor(frame, img, CV_BGR2GRAY);
		else if (frame->nChannels == 4)
			cvCvtColor(frame, img, CV_BGRA2GRAY);

		OpenCVObject *obj = [[OpenCVObject allocWithZone:NULL] initWithValue:img];
		[outputImage setCvObjectValue: obj];
		[obj release];
	}
	else // disconnected or invalid input
	{
		if(img)
		{
			cvReleaseImage(&img);
			img = NULL;
		}
		[outputImage setCvObjectValue: nil];
	}

	return YES;
}

@end
