#import "OpenCVCanny.h"

int aperature[3] =
{3, 5, 7};

@implementation OpenCVCanny : QCPatch

+(BOOL)isSafe
{
	return YES;
}

+ (BOOL)allowsSubpatchesWithIdentifier:(id)fp8
{
	return NO;
}

- (id)initWithIdentifier:(id)fp8
{
	if(self = [super initWithIdentifier:fp8])
	{
		[inputThreshold1 setMinDoubleValue: 0.0];
		[inputThreshold1 setMaxDoubleValue: 300.];
		[inputThreshold1 setDoubleValue: 25.];
		
		[inputThreshold2 setMinDoubleValue: 0.0];
		[inputThreshold2 setMaxDoubleValue: 300.];
		[inputThreshold2 setDoubleValue: 25.];

		[inputAperature setIndexValue: 0];
		[inputAperature setMaxIndexValue: 2];
		
		[inputImage setType: OPENCV_IMAGE];
		[outputImage setType: OPENCV_IMAGE];
	}

	return self;
}

- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments
{
	IplImage *frame = [[inputImage cvObjectValue] value];
	if(frame && frame->nChannels == 1)
	{
		if(img == NULL || frame->width != img->width || frame->height != img->height)
		{
			if(img)
				cvReleaseImage(&img);
			img = cvCreateImage(cvGetSize(frame), frame->depth, 1);
		}
		//NSLog(@"Canny with %f %f %i",[inputThreshold1 doubleValue],[inputThreshold2 doubleValue],[inputAperature indexValue]);
		cvCanny(frame, img, [inputThreshold1 doubleValue],[inputThreshold2 doubleValue],aperature[[inputAperature indexValue]]);
		OpenCVObject *obj = [[OpenCVObject allocWithZone:NULL] initWithValue:img];
		[outputImage setCvObjectValue: obj];
		[obj release];
	}
	else	// no input/invalid colorspace
	{
		if(img)
		{
			cvReleaseImage(&img);
			img = NULL;
			[outputImage setCvObjectValue: nil];
		}
		[outputImage setCvObjectValue:nil];
	}

	return YES;
}

@end
