#import "OpenCVEqualizeHist.h"


@implementation OpenCVEqualizeHist : QCPatch

+(BOOL)isSafe
{
	return YES;
}

+ (BOOL)allowsSubpatchesWithIdentifier:(id)fp8
{
	return NO;
}


- (id)initWithIdentifier:(id)fp8
{
	if(self = [super initWithIdentifier:fp8])
	{
		[inputImage setType: OPENCV_IMAGE];
		[outputImage setType: OPENCV_IMAGE];
	}

	return self;
}

- (void)dealloc
{
	if(img)
		cvReleaseImage(&img);
	[super dealloc];
}

- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments
{
	IplImage *frame = [[inputImage cvObjectValue] value];
	if(frame && frame->nChannels == 1 && frame->depth == 8)
	{
		if(img == NULL || frame->width != img->width || frame->height != img->height)
		{
			if(img)
				cvReleaseImage(&img);
			img = cvCreateImage(cvGetSize(frame), frame->depth, frame->nChannels);
		}
		cvEqualizeHist(frame, img);
		OpenCVObject *obj = [[OpenCVObject allocWithZone:NULL] initWithValue:img];
		[outputImage setCvObjectValue: obj];
		[obj release];
	}
	else
	{
		if(img)
		{
			cvReleaseImage(&img);
			img = NULL;
		}
		[outputImage setCvObjectValue:nil];
	}

	return YES;
}

@end
