#import "OpenCVFindChessboardCorners.h"

@implementation OpenCVFindChessboardCorners : QCPatch

+(BOOL)isSafe
{
	return YES;
}

+ (BOOL)allowsSubpatchesWithIdentifier:(id)fp8
{
	return NO;
}


- (id)initWithIdentifier:(id)fp8
{
	if(self = [super initWithIdentifier:fp8])
	{
		[inputImage setType: OPENCV_IMAGE];
		[inputAdaptiveThreshold setBooleanValue:TRUE];
	}

	return self;
}

- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments
{
	IplImage	*frame = [[inputImage cvObjectValue] value];
	QCStructure *corners;
	if(frame && [inputInnerRows indexValue] > 2 && [inputInnerColumns indexValue] > 2 && [inputFind booleanValue])
	{
		int cornerCount;
		int flags = 0;
		int ret, i;
		CvPoint2D32f	*pointSeq = (CvPoint2D32f*)malloc(sizeof(CvPoint2D32f) * [inputInnerRows indexValue] * [inputInnerColumns indexValue]);
		
		flags |= CV_CALIB_CB_ADAPTIVE_THRESH * [inputAdaptiveThreshold booleanValue];
		flags |= CV_CALIB_CB_NORMALIZE_IMAGE * [inputNormalize booleanValue];
		flags |= CV_CALIB_CB_FILTER_QUADS * [inputFilterQuads booleanValue];
		
		ret = cvFindChessboardCorners( frame, cvSize([inputInnerRows indexValue],[inputInnerColumns indexValue]),
                             pointSeq, &cornerCount, flags);
		[outputCornerCount setIndexValue: cornerCount];
		[outputAllFound setBooleanValue: ret];
		
		corners = [[QCStructure alloc] init];
		
		for(i=0; i<cornerCount; ++i)
		{
			QCStructure *p = [[QCStructure allocWithZone:NULL] init];
			[p addMember:[NSNumber numberWithDouble:CV2QC(pointSeq[i].x,frame->width)] forKey:@"X"];
			[p addMember:[NSNumber numberWithDouble:CV2QC(pointSeq[i].y,frame->height)*frame->height/frame->width] forKey:@"Y"];
			[corners addMember: p forKey:[NSString stringWithFormat:@"Corner%04i",i]];
			[p release];
		}
		[outputCorners setStructureValue: corners];
		[corners release];
		
		free(pointSeq);
	}

	return YES;
}

@end
