#import "OpenCVLoad.h"

@implementation OpenCVLoad

// Intentionally not marked as a "safe" patch, since it reads from disk.


+ (BOOL)allowsSubpatchesWithIdentifier:(id)fp8
{
	return NO;
}


- (id)initWithIdentifier:(id)fp8
{
	if(self = [super initWithIdentifier:fp8])
	{
		[outputData setType: OPENCV_HAAR];
	}

	return self;
}

- (void)dealloc
{
	if(cascade)
		cvReleaseHaarClassifierCascade(&cascade);
	[super dealloc];
}

- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments
{
	//NSLog(@"CVLoad @ %f",time);
	NSString *path = KIExpandPath(self,[inputPath stringValue]);
	if( [path length] > 0 )
	{
		cascade = (CvHaarClassifierCascade*)cvLoad([path cStringUsingEncoding: NSASCIIStringEncoding],0,0,0);
		
		OpenCVObject *obj = [[OpenCVObject allocWithZone:NULL] initWithValue:cascade];
		[outputData setCvObjectValue: obj];
		[obj release];
	}
	else	// empty string
	{
		if(cascade)
		{
			cvReleaseHaarClassifierCascade(&cascade);
			cascade = NULL;
		}
		[outputData setCvObjectValue: nil];
	}

	return YES;
}

@end
