#import "OpenCVPrincipal.h"

// Standard OpenCV API Function Patches
//#import "OpenCVCameraCapture.h"
#import "OpenCVBGR2Gray.h"
#import "OpenCVGoodFeaturesToTrack.h"
#import "OpenCVCanny.h"
#import "OpenCVCalcOpticalFlowPyrLK.h"
#import "OpenCVFindCornerSubPix.h"
#import "OpenCVEqualizeHist.h"
#import "OpenCVResize.h"
#import "OpenCVLoad.h"
#import "OpenCVHaarDetectObjects.h"
#import "OpenCVHoughLines2.h"
#import "OpenCVRNG.h"
#import "OpenCVLogPolar.h"
#import "OpenCVFastCameraYUV.h"
#import "OpenCVFindChessboardCorners.h"

// QC Interface Glue Function Patches
#import "OpenCVImageToQCImage.h"
#import "QCImageToOpenCVImage.h"
#import "QCImageToGrayCVImage.h"

@implementation OpenCVPlugin
+ (void)registerNodesWithManager:(GFNodeManager*)manager
{
	cvSetErrMode( CV_ErrModeParent );	// don't crash/quit on cv error

	//KIRegisterPatch(OpenCVCameraCapture);
	KIRegisterPatch(OpenCVBGR2Gray);
	KIRegisterPatch(OpenCVGoodFeaturesToTrack);
	KIRegisterPatch(OpenCVCalcOpticalFlowPyrLK);
	KIRegisterPatch(OpenCVCanny);
	//KIRegisterPatch(OpenCVFindCornerSubPix);
	KIRegisterPatch(OpenCVEqualizeHist);
	KIRegisterPatch(OpenCVResize);
	KIRegisterPatch(OpenCVLoad);
	KIRegisterPatch(OpenCVHaarDetectObjects);
	KIRegisterPatch(OpenCVHoughLines2);
	//KIRegisterPatch(OpenCVRNG);
	KIRegisterPatch(OpenCVLogPolar);
	//KIRegisterPatch(OpenCVFastCameraYUV);
	KIRegisterPatch(OpenCVFindChessboardCorners);
	KIRegisterPatch(OpenCVImageToQCImage);
	KIRegisterPatch(QCImageToOpenCVImage);
	//KIRegisterPatch(QCImageToGrayCVImage);
}
@end
