// rather than making a million type ports, we make one and have it know what kind it is.
typedef enum
{
	OPENCV_UNDEFINED=0,	// this one won't work with anything, and should be considered a bug if it's found in the wild.
	OPENCV_IMAGE,		// IplImage *
	OPENCV_SEQ,			// CvSeq *
	OPENCV_HAAR,		// CvHaarClassifierCascade *
	OPENCV_MATRIX,		// CvMat *
	OPENCV_VECTOR,		// CvVect *
	OPENCV_POSIT,		// CvPOSITObject *
	OPENCV_RNG,			// Random Number Generator objects
} OpenCVType;

// x is a float, y is a float (width/height)
#define CV2QC(x, y) ( (((float)(x)) - ((y)/2.f)) / ((y)/2.f))
#define QC2CV(x, y) ( (((float)(x)) * ((y)/2.f)) + ((y)/2.f))

@interface OpenCVObject : NSObject
{
	void *data;
}
-(id)initWithValue:(void*)val;
- (void*)value;
- (void)setValue:(void*)val;
@end

@interface OpenCVTypePort : QCObjectPort
{
	OpenCVType type;
}

+ (Class)baseClass;
- (Class)objectClass;
- (OpenCVObject*)cvObjectValue;
- (void)setCvObjectValue:(OpenCVObject*)obj;
- (OpenCVType)type;
- (void)setType:(OpenCVType)newType;

@end
