#import "OpenCVTypePort.h"

@implementation OpenCVObject
-(id)initWithValue:(void*)val
{
	if(self = [super init])
		data = val;
	return self;
}

- (void*)value
{
	return data;
}
- (void)setValue:(void*)val
{
	data = val;
}
@end


@implementation OpenCVTypePort
+ (Class)baseClass
{
	return [OpenCVTypePort class];
}
- (Class)objectClass
{
	return [OpenCVObject class];
}

- (OpenCVObject*)cvObjectValue
{
	return [self object];
}
- (void)setCvObjectValue:(OpenCVObject*)obj
{
	[self setObject:obj];
}

- (OpenCVType)type
{
	return type;
}
- (void)setType:(OpenCVType)newType
{
	type = newType;
}

- (BOOL)canConnectToPort:(QCPort*)port
{
	if( [port isKindOfClass:[OpenCVTypePort class]] )
	{
		//NSLog(@"type: %i  remote type: %i",type, [(OpenCVTypePort*)port type]);
		if( type && [(OpenCVTypePort*)port type] == type )
			return YES;
		return NO;	// if they don't match types, bail here so the virtual port test below doesn't pass anyway
	}
	// ObjectPorts are subclasses of virtual ports.  as such, we check against this last rather than first
	if( [port isMemberOfClass:[QCVirtualPort class]] )
		return YES;
	return NO;
}

@end
