#import "QCImageToGrayCVImage.h"

@implementation QCImageToGrayCVImage : QCPatch

+(BOOL)isSafe
{
	return YES;
}

+ (BOOL)allowsSubpatchesWithIdentifier:(id)fp8
{
	return NO;
}

- (id)initWithIdentifier:(id)fp8
{
	if(self = [super initWithIdentifier:fp8])
	{
		[outputImage setType: OPENCV_IMAGE];
		obj = [OpenCVObject new];
	}

	return self;
}

- (void)cleanup:(QCOpenGLContext *)context
{
	// XXX -- should we release obj here, or in dealloc (since it's created in init)...
	[obj release];
	if(img)
		cvReleaseImage(&img);
	[super cleanup];
}


- (void)enable:(QCOpenGLContext *)context
{
	cs = CGColorSpaceCreateWithName(kCGColorSpaceGenericRGB);
	pf = [QCPixelFormat pixelFormat422YpCbCr8_601];
}
- (void)disable:(QCOpenGLContext *)context
{
	CGColorSpaceRelease(cs);
}


- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments
{
	QCImage	*inImg = [inputImage imageValue];
	if(inImg && [inImg isInfinite] == FALSE)
	{
		if(img == NULL || img->width != [inImg bounds].size.width || img->height != [inImg bounds].size.height)
		{
			if(img)
				cvReleaseImage(&img);
			img = cvCreateImage(cvSize((int)[inImg bounds].size.width,(int)[inImg bounds].size.height),8,4);
		}
		IplImage fImg;
		QCImagePixelBuffer * pb = [inImg createPixelBufferForManager:[context imageManager] 
				withFormat: pf
				bounds: [inImg bounds]
				colorSpace: cs
				options:nil];
				fImg.nSize = sizeof(IplImage);
		//fImg.ID = 0;
		fImg.imageData = [pb baseAddress];
		fImg.nChannels = 3;
		fImg.depth = 8;
		fImg.dataOrder = 0;
		fImg.width = [inImg bounds].size.width;
		fImg.height = [inImg bounds].size.height;
		fImg.roi = NULL;
		//fImg.maskROI = NULL;
		fImg.imageSize = fImg.height * [pb bytesPerRow];
		fImg.widthStep = [pb bytesPerRow];
		fImg.imageDataOrigin = fImg.imageData;
		//memcpy(img->imageData, [pb baseAddress],[inImg bounds].size.width*[inImg bounds].size.height*4);
		//img->imageData = [pb baseAddress];
		//unsigned int i;
		/*for(i=0;i<4;++i)
			img->imageData[i]=0x4f<<i;*/
		cvCvtColor(&fImg, img, );
		cvFlip(img, img, -1);
		[obj setValue:img];
		[outputImage setCvObjectValue:obj];
		
		//QCImage *val=[[QCImage alloc] initWithQCImageBuffer:pb options:nil];
		
		//[outputImg setImageValue: val];
		//[val release];
		[pb release];

	}
	else
	{
		if(img)
		{
			cvReleaseImage(&img);
			img = NULL;
		}
		[outputImage setCvObjectValue: nil];
	}

	return YES;
}

@end
